;  "Printing With AB" Disassembly
;  by Al Rathmell
;  ARCADIAN 5, no. 2 (Dec. 3, 1982): 43. 
;  For the Bally Arcade/Astrocade with AstroBASIC
;
;  This is a short driver program for using a printer with AstroBASIC
;  and the old-style printer interface that was popular to use
;  with Bally BASIC.
;
;  Assembly Program Name - PRINTAB.ASM
;  Version 1.0 - July 4, 2013, Disassembly by Adam Trionfo
;              - First public release 
;
;  Tools Used: 1) dZ80 v2.0 (Disassembler), by Mark Incley
;              2) PSPad v4.5.4 (Text Editor), by Jan Fiala
;              3) Zmac v1.3 (MacroCross-Assembler)[Compiled for Windows]
;                 by Bruce Norskog and others  
;
;  "Printing With AB" is stored in the bottom of screen RAM at
;  locations 20258-20344+1 ($4F22-$4F79).  The article calls this area,
;  "a normally unused portion of RAM memory (bottom of stackarea)."
;  
;  Two BASIC instructions are used to enable or disable the function:
;
;     1 - To Enable (the equivalent of *PRINT)
;
;         %(20124) = 20258
;
;     2 - To Disable (the equivalent of :RETURN)
;
;         %(20124) = 11531
;
;  Read the article in the Arcdian to learn more about the program.
;
        ORG     $4F22          ; ORG 20258 Decimal

L4F22:  PUSH    AF             ; Start of Program (Enable Function)
        EXX     
        CALL    L4F2A
        POP     AF
        EXX     
        RET     

L4F2A:  CP      $78
        JR      NC,L4F32
        CP      $68
        JR      NC,L4F65
L4F32:  NOP     
        LD      D,A
        LD      C,D
        RLC     C
L4F37:  IN      A,($12)
        AND     $02
        JR      Z,L4F37
        LD      B,$0A
L4F3F:  LD      A,$C0
L4F41:  DEC     A
        JR      NZ,L4F41
        DEC     B
        JR      Z,L4F5F
        IN      A,($12)
        LD      E,A
L4F4A:  IN      A,($12)
        XOR     E
        AND     $02
        JR      Z,L4F4A
        LD      A,E
        XOR     C
        AND     $02
        JR      Z,L4F59
        IN      A,($12)
L4F59:  SET     1,C
        RRC     C
        JR      L4F3F
L4F5F:  NOP     
        LD      A,D
        CALL    $2D13         ; Call to AstroBASIC ROM VDM (Video
;                               Display Module) Routine.
        RET     

L4F65:  CALL    $2F2A         ; Call to AstroBASIC ROM TOKEP
;                               (DISPLAY A TOKEN IN FULL FORM) Routine

L4F68:  LD      A,(HL)
        AND     $7F
        PUSH    HL
        CALL    L4F32
        POP     HL
        LD      A,(HL)
        INC     HL
        RLCA    
        JR      NC,L4F68
        LD      A,$20
L4F77:  JP      L4F32          ; Labeled only to show last line of program

        NOP                    ; Two NOPs added to match last two
        NOP                    ; bytes of digitally archived program     

END                            ; End of Assembly
